'use strict';

var RelatorioComprasController = angular.module('RelatorioComprasController', []);

RelatorioComprasController.controller('RelatorioComprasCtrl', ['$scope', '$filter', 'Solicitacao', 'CacheApp',
  ($scope, $filter, Solicitacao, CacheApp) => {

    $scope.getRelatorioCompras = () => {
        var params = {
            IdConstrucao: $scope.construcao.Id,
            IdSolicitacaoSituacao: $scope.filtro.Situacao.Id,
            Prioridade: $scope.filtro.Prioridade.Id
        }
        Solicitacao.getRelatorioCompras(params,
            (data) => {
                $scope.listaCompras = data.Instance;
            })
    }

    $scope.getSolicitacaoSituacao = () => {
        Solicitacao.getSolicitacaoSituacao(
            (data) => {
                $scope.listaSolicitacaoSituacao = data.Instance;
                $scope.listaSolicitacaoSituacao.unshift({Id: 0, Nome: 'TODOS'});
            }
        );
    }

    $scope.pdfRelatorioCompras = () => {
        var cabecalho = {
            Avatar: $scope.construcao.ContaAvatar,
            Obra: $scope.construcao.Titulo,
            Conta: $scope.construcao.Conta,
            DataInicio: $filter("date")($scope.construcao.DataInicio, 'dd/MM/yyyy'),
            DataFim: $filter("date")($scope.construcao.DataFim, 'dd/MM/yyyy'),
            Moeda: $scope.construcao.Moeda
        };

        var params = {
            IdConstrucao: $scope.construcao.Id,
            IdSolicitacaoSituacao: $scope.filtro.Situacao.Id,
            Prioridade: $scope.filtro.Prioridade.Id,
            Cabecalho: JSON.stringify(cabecalho)
        }

        Solicitacao.pdfRelatorioCompras(params,
            (data) => {
                window.location.assign(data.Instance);
            });
    }  

    $scope.xlsRelatorioCompras = function () {
        var cabecalho = {
            Avatar: $scope.construcao.ContaAvatar,
            Obra: $scope.construcao.Titulo,
            Conta: $scope.construcao.Conta,
            DataInicio: $filter("date")($scope.construcao.DataInicio, 'dd/MM/yyyy'),
            DataFim: $filter("date")($scope.construcao.DataFim, 'dd/MM/yyyy'),
            Moeda: $scope.construcao.Moeda
        }

        var params = {
            IdConstrucao: $scope.construcao.Id,
            IdSolicitacaoSituacao: $scope.filtro.Situacao.Id,
            Prioridade: $scope.filtro.Prioridade.Id,
            Cabecalho: JSON.stringify(cabecalho)
        }

        Solicitacao.xlsRelatorioCompras(params,
            (data) => {
                window.location.assign(data.Instance);
            })
    }

    $scope.loadPage = () => {
        $scope.construcao = CacheApp.getConstrucao();

        $scope.filtro = {
            Situacao: {Id: 0, Nome: 'TODOS'},
            Prioridade: {Id: 0, Nome: 'TODOS'}
        };

        $scope.getRelatorioCompras();
        $scope.getSolicitacaoSituacao();

        $scope.listaPrioridade = [
            {Nome: 'TODOS', Id: 0},
            {Nome: 'BAIXA', Id: 1},
            {Nome: 'MÉDIA', Id: 2},
            {Nome: 'ALTA', Id: 3},
        ];
    }

    $scope.loadPage();

}]);
